"""
Django settings for middleware project.

Generated by 'django-admin startproject' using Django 1.8.18.

For more information on this file, see
https://docs.djangoproject.com/en/1.8/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.8/ref/settings/
"""

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
import os

BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.8/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'pdwz7$ri#+w4a#g309qjr3$4kv#nn2l)v^nddh3w0cr_#825y$'

# secret key for API request
API_SECRET_KEY = "MI459571ab0b28c4d49935758465665f62"

# Platform secret key
CLIENT_SECRET_KEY = 'AH-cfb618dd24b34810ae56b07dc8bb7e2d'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['127.0.0.1', '192.168.22.22', 'flif-dev.local', 'flif-dev.pub',
                 'prod-flif-middleware-01.cloud.alemhealth.com',
                 'prod-flif-middleware-02.cloud.alemhealth.com',
                 'prod-flif-middleware-03.cloud.alemhealth.com',
                 'dev-middleware-1019558842.ap-southeast-1.elb.amazonaws.com']


# Application definition

INSTALLED_APPS = (
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework_docs',
    'corsheaders',
    'rest_framework',
    'flif',
)

MIDDLEWARE_CLASSES = (
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
)

ROOT_URLCONF = 'middleware.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'middleware.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.8/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
    }
}


# Internationalization
# https://docs.djangoproject.com/en/1.8/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.8/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static/')

# Logging
LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'verbose': {
            'format': '[%(asctime)s] %(levelname)s [%(pathname)s:%(lineno)d] %(message)s',
            'datefmt': "%d/%b/%Y %H:%M:%S"
        },
    },
    'handlers': {
        'file': {
            'level': 'DEBUG',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/var/log/alemhealth/middleware.log',
            'mode': 'a',
            'maxBytes': 50 * 1024 * 1024,  # 10 MB LOG FILE SIZE
            'backupCount': 5,
            'encoding': None,
            'delay': 0,
            'formatter': 'verbose'
        },
        'error': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/var/log/alemhealth/error.log',
            'mode': 'a',
            'maxBytes': 50 * 1024 * 1024,  # 10 MB LOG FILE SIZE
            'backupCount': 2,
            'encoding': None,
            'delay': 0,
            'formatter': 'verbose'
        },
    },
    'loggers': {
        'middleware': {
            'handlers': ['file', 'error'],
            'propagate': True,
            'level': 'DEBUG',
        },
        'django.request': {
            'handlers': ['file'],
            'level': 'DEBUG',
            'propagate': True,
        },
    },
    'xhtml2pdf': {
        'handlers': ['logfile'],
        'level': 'DEBUG'
    },
}


MEDIA_ROOT = os.path.join(BASE_DIR, 'media')

"""
DRF doc settings
"""
REST_FRAMEWORK_DOCS = {
    'HIDE_DOCS': False
}

CORS_ORIGIN_WHITELIST = (
    '127.0.0.1:8000', '192.168.2.22', '52.77.218.142'
)

if os.path.isfile(BASE_DIR + '/middleware/local_settings.py'):
    from local_settings import *